Subject: Re: bug#63666: sporadic “guix substitute: error: connect*: Connection timed out”

From: Ludovic Courtès <[email-masked]>
Date: Fri, 26 May 2023 18:47:11 +0200

Simon Tournier <[email-masked]> skribis:

> On mer., 24 mai 2023 at 17:01, Ludovic Courtès <[email-masked]> wrote:
>
>>>  gumbo-parser-0.10.1  149KiB                                                                                                                                                                       555KiB/s 00:00 ▕██████████████████▏ 100.0%
>>>  cups-minimal-2.4.2  4.9MiB                                                                                                                                                                        533KiB/s 00:03 ▕█████▎            ▏  29.2%guix substitute: warning: while fetching https://ci.guix.gnu.org/nar/lzip/mcdi162f45smrgvjmm3vldx2i1xhz0x5-iso-codes-4.5.0: server is somewhat slow
>>> guix substitute: warning: try `--no-substitutes' if the problem persists
>>> retrying download of '/gnu/store/mcdi162f45smrgvjmm3vldx2i1xhz0x5-iso-codes-4.5.0' with other substitute URLs...
>>
>> Good, that’s the expected behavior.  (Of course that may still fail if
>> there are no other valid substitute URLs.)
>
> Well, I do not have other substitutes and sometimes it displays this
> message but it does not fail.  Does it retry?

The warning is just that: a warning.  It’s telling you that the thing is
slow.

In the case above, on top of being slow, something went wrong, which is
why it tried again with another URL.

>>> No more progress bars.
>>
>> That’s because you have max-jobs > 1: progress bars aren’t displayed
>> when several jobs are running in parallel.
>
> Well, I only see this “substitution of …” message when before the
> progress bar is broken by a warning.  Then I do not see again any
> progress bar.

Hmm interesting.  I wouldn’t think the progress bar can be “broken” by
the warning, but maybe there’s something fishy going on that leads (guix
status) to think one of the substitution jobs never finished, which is
why it falls back to no-progress-bar behavior.

Thanks,
Ludo’.